"""
Configs migration

Generation datetime: 2021-12-14 09:48:46.093214
"""

from typing import List

from configs_core.migration.db_migrate_helper import DatabaseMigrationHelper, LimitationToModify

mh: DatabaseMigrationHelper

REVISION = "096fc21a"
DOWN_REVISION = "6a1b732d"


limitationsToModify: List[LimitationToModify] = [
    LimitationToModify(
        limitationName="INFLUX_MONITORING",
        oldDefaultValue={
            "send_data_for_monitoring": 0,
            "version": 1,
            "use_ssl": 0,
            "flushing_period": 1,
            "host": "127.0.0.1",
            "port": 8086,
            "database_name": "luna_monitoring",
            "user_name": "luna",
            "password": "luna",
        },
        newDefaultValue={
            "send_data_for_monitoring": 1,
            "version": 1,
            "use_ssl": 0,
            "flushing_period": 1,
            "host": "127.0.0.1",
            "port": 8086,
            "database_name": "luna_monitoring",
            "user_name": "luna",
            "password": "luna",
        },
        settingUpgradeFunction=lambda x: x,
        settingDowngradeFunction=lambda x: x,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-admin",
            "luna-api",
            "luna-backport3",
            "luna-backport4",
            "luna-configurator",
            "luna-events",
            "luna-faces",
            "luna-handlers",
            "luna-image-store",
            "luna-index-manager",
            "luna-licenses",
            "luna-matcher-proxy",
            "luna-python-matcher",
            "luna-sender",
            "luna-tasks",
        ],
        newServices=[
            "luna-admin",
            "luna-api",
            "luna-backport3",
            "luna-backport4",
            "luna-configurator",
            "luna-events",
            "luna-faces",
            "luna-handlers",
            "luna-image-store",
            "luna-index-manager",
            "luna-licenses",
            "luna-matcher-proxy",
            "luna-python-matcher",
            "luna-sender",
            "luna-tasks",
        ],
    ),
]


def upgrade():
    """Upgrade configs to new revision"""

    # limitations to modify
    for limitation in limitationsToModify:
        mh.migrateLimitation(limitation)


def downgrade():
    """Downgrade configs to previous revision"""

    # limitations to modify
    for limitation in limitationsToModify:
        mh.migrateLimitation(limitation)
